/*
 * This is Tampa Ping-Pong convers/conversd derived from the wampes
 * convers package written by Dieter Deyke <deyke@mdddhd.fc.hp.com>
 *
 * By Brian A. Lantz/KO4KS <brian@lantz.com>
 * Mods by Brian Rogers/N1URO <n1uro@n1uro.com>
 */

#include <stdio.h>
#include <errno.h>
#include <limits.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "conversd.h"
#include "version.h"
#include "user.h"
#include "log.h"
#include "config.h"

#define SMILEYFile "/smileys.txt"
#define SPAMFile "/spam.txt"
#define ConfNews "/convers.news"
/* #define Quotes "/usr/lib/quotes" */
#define READ_TEXT "r"
#define NULLFILE ((FILE *) 0)
static char cutstr[] = "%s%s has cut the deck and selected the %s of %s!! %s";
static char rollstr[] = "%s%s has rolled a %d and a %d for a total of %d! %s";
static char bjackstr[] = "%s%s has drawn %d and %d in 21-stud for a total of %d! %s";
static char summary[] = "%sconversd Tampa PingPong-Release %4.4s Command Summary:\n ";
static char noopenstr[] = "Can't open '%s'\n";
static char nicknmstr[] = "Nickname ";
static char nicknamestr[] = "%s%s%sset to '%s'.\n";
static char uaddstr[] = "/\377\200UADD %s %s %s %d %s\n";
static char systemstr[] = "SYSTEM";
/* static char quotebanner[] = " *** Quote of the day: \n"; */
static char tmstr[] = "Time";
char stars[] = "*** ";
static char conversd[] = "conversd";

char *Days[7] =
{"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
char *Months[12] =
{"Jan", "Feb", "Mar", "Apr", "May", "Jun",
 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};



long seed = 1L;
#define CONV_RAND_MAX 0x7fffffff

int conv_rand(void)
{
	seed = (1103515245L * seed + 12345) & CONV_RAND_MAX;
	return ((int) (seed & 077777));
}

void conv_randomize(void)
{
	seed = (time(0) & CONV_RAND_MAX);
}

int conv_random(int num, int base)
{
	return (((long) conv_rand() % num) + base);
}

static char *suits[] = {"Hearts", "Clubs", "Diamonds", "Spades"};
static char *cards[] = {"Ace", "Two", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten", "Jack", "Queen", "King", "Joker"};

void rip(char *str)
{
	if ((str[strlen(str) - 1] == '\n') || (str[strlen(str) - 1] == '\r'))
		str[strlen(str) - 1] = '\0';
}


char *skipwhite(char *cp)
{
	while (*cp && (*cp == ' ' || *cp == '\t'))
		cp++;
	return (cp);
}


char *skipnonwhite(char *cp)
{
	while (*cp && *cp != ' ' && *cp != '\t')
		cp++;
	return (cp);
}

void smiley_command(struct connection *cp)
{
int offset, k;
char buff[200];
FILE *fp;

	strcpy(buff, CONF_DIR);
	strcat(buff, SMILEYFile);
	
	conv_randomize();
	offset = conv_random (7, 1);
	if (!(fp = fopen (buff, "r")))
		return;
	sprintf (buff, "%sSmiley: ", stars);
	for (k = 0; k < offset; k++)
		fgets (&buff[12], 188, fp);
	fclose (fp);
	rip (buff);
	clear_locks ();
	send_msg_to_channel (conversd, cp->channel,buff);
}

void spam_command(struct connection *cp)
{
int offset, k;
char buff[200];
FILE *fp;
	
	strcpy(buff, CONF_DIR);
	strcat(buff, SPAMFile);
	
	conv_randomize();
	offset = conv_random (10, 1);
	if (!(fp = fopen (buff, "r")))
		return;
	sprintf (buff, "%sdaemon: ", stars);
	for (k = 0; k < offset; k++)
		fgets (&buff[12], 188, fp);
	fclose (fp);
	rip (buff);
	clear_locks ();
	send_msg_to_channel (conversd, cp->channel,buff);
}


void time_command(struct connection *cp)
{
	time_t currtime;
	char buff[80];

	currtime = time(&currtime);
	sprintf(buff, "%s%s at %s is %s\n", stars, tmstr, myhostname, ts(currtime));
	rip(buff);
	clear_locks();
	send_msg_to_channel(conversd, cp->channel, buff);
}

static int DisplayFile(char *filename, struct connection *cp)
{
	FILE *fdi;
	char buffer[2048];
	int retval = 0;

	if (!access(filename, R_OK)) {
		fdi = fopen(filename, "r");
		buffer[0] = '*';
		buffer[1] = ' ';
		while (!feof(fdi)) {
			fgets(buffer + 2, 2045, fdi);
			if (!feof(fdi))
				appendstring(cp, buffer);
		}
		fclose(fdi);
		retval = 1;
	}
	return (retval);
}



void tnoshelp_command(struct connection *cp)
{
	int k;
	char *cptr;
	char file2open[200];

	cptr = getarg(0, 0);

	strcpy(file2open, CONF_DIR);
	strcat(file2open, ConfNews);
	k = DisplayFile(file2open, cp);
	if (!k) {
		char buf[300];
		sprintf(buf, noopenstr, file2open);
		appendstring(cp, buf);
	}
	appendprompt(cp, 1);
}

void
roll_command(struct connection *cp)
{
int die1, die2;
char buff[2048];
char buf[(NAMESIZE * 2) + 2];

	conv_randomize();
	die1 = conv_random (6, 1);
	die2 = conv_random (6, 1);
 	clear_locks ();
	getTXname (cp, buf);
	sprintf (buff, rollstr, stars, buf, die1, die2, die1+die2, stars);
	send_msg_to_channel(conversd,cp->channel,buff);
}

void bjack_command(struct connection *cp)
{
int die1, die2;
char buff[2048];
char buf[(NAMESIZE * 2) + 2];

	conv_randomize();
	die1 = conv_random (11,1);
	die2 = conv_random (11,1);
	clear_locks ();
	getTXname (cp, buf);
	sprintf (buff, bjackstr, stars, buf, die1, die2, die1+die2, stars);
	send_msg_to_channel(conversd,cp->channel,buff);
}

void cut_command(struct connection *cp)
{
 int die1, die2;
 char buff[2048];
 char buf[(NAMESIZE * 2) + 2];
 
 	conv_randomize();
 	die1 = conv_random (4, 0);
 	die2 = conv_random (14, 0);
 	clear_locks ();
 	getTXname (cp, buf);
 	sprintf (buff, cutstr, stars, buf, cards[die2], suits[die1], stars);
 	send_msg_to_channel(conversd,cp->channel,buff);
}
 	
void news_command(struct connection *cp)
{
	char buf[8];

	strcpy(buf, "news");
	setargp(buf);
	tnoshelp_command(cp);
}


void cmdsummary_command(struct connection *cp)
{
	int i;
	char buf[82];
	char buf2[100];
	struct cmdtable *cmdp = cmdtable;
	int width = 13, count = 6;
	struct extendedcmds *ecmdp;

	sprintf(buf2, summary, stars, SOFT_RELEASE);
	appendstring(cp, buf2);
	memset(buf, ' ', sizeof(buf));
	buf[78] = '\n';
	buf[79] = '\0';
	for (i = 0; cmdp->name; cmdp++, i = ((i + 1) % count)) {
		if ((unsigned char) *cmdp->name == 255)
			break;	/* skip hosts commands */
		if (cmdp->states == CM_UNKNOWN) {
			i--;
			continue;	/* skip non-user commands */
		}
		if (*cmdp->name == '/') {
			i--;
			continue;	/* skip invisible commands */
		}
		strncpy(&buf[i * width], cmdp->name, strlen(cmdp->name));
		if (i == (count - 1)) {
			sprintf(buf2, "%s ", buf);
			appendstring(cp, buf2);
			memset(buf, ' ', 78);
		}
	}
	if (i)
		appendstring(cp, buf);
	else
		appendstring(cp, "\n");
	if (ecmds != NULLEXTCMD && ecmds->name) {
		ecmdp = ecmds;
		memset(buf, ' ', sizeof(buf));
		buf[79] = '\n';
		buf[80] = '\0';
		sprintf(buf2, "\n%sExtended Remote Commands:\n ", stars);
		appendstring(cp, buf2);
		for (i = 0; ecmdp && ecmdp->name; ecmdp = ecmdp->next, i = ((i + 1) % count)) {
			strncpy(&buf[i * width], ecmdp->name, strlen(ecmdp->name));
			if (i == (count - 1)) {
				sprintf(buf2, "%s ", buf);
				appendstring(cp, buf2);
				memset(buf, ' ', 78);
			}
		}
		if (i)
			appendstring(cp, buf);
		else
			appendstring(cp, "\n");
	}
	appendprompt(cp, 1);
}
/* Quote server for future reference...

void quote_command(struct connection *cp)
{
char buf2[512];
char searchstr[5];
char *cptr;
FILE *fp;
int dt;
time_t tm;

	if ((fp = fopen(Quotes,READ_TEXT)) == NULLFILE)
		return;
	tm = time((time_t *)0);
	dt = atoi (&(ctime(&tm))[8]);
	sprintf (searchstr, "[%-d]", dt);
	while(fgets(buf2,512,fp) ! = NULLCHAR)	{
		if (!strncmp (searchstr, buf2, strlen(searchstr)))
			break;
	}
	if ((cptr = strchr (buf2, '%')) ! = NULLCHAR) 	{
		rip (buf2);
		fclose (fp);
		if ((fp = fopen (++cptr,READ_TEXT)) == NULLFILE)	{
			printf ("Couldn't open '%s'\n", &buf2[1]);	
			return;
		}
	}
	clear_locks ();
	send_msg_to_channel(conversd,cp->channel,quotebanner);
	clear_locks ();
	while(fgets(buf2,512,fp) ! = NULLCHAR)	{
		if (*buf2 == '[')
			break;
		rip(buf2);
		send_msg_to_channel(conversd,cp->channel,buf2);
		clear_locks ();
	}
	send_msg_to_channel(conversd,cp->channel,stars);
	fclose (fp);
}
*/	

void h_loop_command(struct connection *cp)
{
	char *host;

	host = getargcs(0, 0);
	log(L_R_ERR, "conversd rx: LOOP %s", host);
	bye_command(cp);
}



/* Send updated personal data, nickname, and password */
void update_user_data(struct connection *cp, int personal)
{
	struct connection *p;
	char buffer[2048];
	/* update all links */
	for (p = connections; p; p = p->next) {
/* #define DEBUG */
#ifdef DEBUG
		if (p->type == CT_HOST)
			printf("Update Features: '%s' %s%s%s%s%s%s\n", p->name,
			       (p->features & FEATURE_AWAY) ? "a" : "",
			       (p->features & FEATURE_FWD) ? "d" : "",
			       (p->features & FEATURE_MODES) ? "m" : "",
			       (p->features & FEATURE_LINK) ? "p" : "",
			       (p->features & FEATURE_UDAT) ? "u" : "",
			       (p->features & FEATURE_NICK) ? "n" : "");
#endif
		if (p->type == CT_HOST) {
			if (personal)
				send_user_change_msg(cp->name, cp->host, cp->channel, cp->channel, cp->pers, cp->time, 0);
			if (p->features & FEATURE_NICK) {
				sprintf(buffer, uaddstr,
					cp->name, cp->host, cp->nickname, -1, cp->pers ? cp->pers : "~~");
				linklog(p, L_SENT, "%s", &buffer[3]);
				appendstring(p, buffer);
			}
		}
	}
}


void nickname_command(struct connection *cp)
{
	char usernotefile[PATH_MAX];
	char buf[80];
	int err = 0;
	char *new;
	int unf;

	strcpy(usernotefile, DATA_DIR);
	strcat(usernotefile, "/nicknames/");
	strcat(usernotefile, cp->name);
	new = getargcs(0, 0);
	if (new && *new) {
		if (strcasecmp(new, systemstr) && strcasecmp(new, conversd)) {
			strncpy(cp->nickname, new, NAMESIZE);
			if ((unf = creat(usernotefile, 0644)) != -1) {
				write(unf, new, strlen(new));
				close(unf);
			}
		} else {
			sprintf(buf, nicknamestr, stars, nicknmstr, "can't be ", new);
			appendstring(cp, buf);
			err = 1;
		}
	}
	sprintf(buf, nicknamestr, stars, nicknmstr, "", cp->nickname);
	appendstring(cp, buf);
	if (!err)
		update_user_data(cp, 0);
}




void nonickname_command(struct connection *cp)
{
	char buf[PATH_MAX];

	strcpy(cp->nickname, cp->name);
	sprintf(buf, nicknamestr, stars, nicknmstr, "re", cp->nickname);
	appendstring(cp, buf);
	strcpy(buf, DATA_DIR);
	strcat(buf, "/nicknames/");
	strcat(buf, cp->name);
	unlink(buf);
	update_user_data(cp, 0);
}




void realname_command(struct connection *cp)
{
	char *name;
	char buf[80];

	name = getarg(0, 0);
	sprintf(buf, "r %s", name);
	setargp(buf);
	who_command(cp);
}



/* Command to take user's personal data across a link */
void h_uadd_command(struct connection *cp)
{
	char *name, *host, *data, *nickname, *channel;
	struct connection *p;

	name = getarg(0, 0);
	host = getarg(0, 0);
	nickname = getargcs(0, 0);
	channel = getarg(0, 0);
	data = getarg(0, 1);
	if (*data == '~' && data[1] == '~')
		*data = 0;

	for (p = connections; p; p = p->next)
		if (!strcasecmp(p->name, name) && !strcasecmp(p->host, host)) {
			strncpy(p->nickname, nickname, NAMESIZE);
			strncpy(p->pers, data, PERSSIZE);
			break;
		}
}

/*------------------------------------------------------------------------*/

#define WxProg "/usr/local/bin/wx"

void wx_command(struct connection *cp)
{
	char *cptr;
	char str[256];
	FILE *fp;
	
	cptr = getarg(0, 0);
	
	if ((fp = popen(WxProg, "r")) == NULL) {
		sprintf(str, "*** popen: %s\n", strerror(errno));
		appendstring(cp, str);
		appendprompt(cp, 0);
	} else {
		strcpy(str, "*** ");
		if (fgets(str + 4, 251, fp) != NULL) {
			rip(str);
			clear_locks();
			send_msg_to_channel(conversd, cp->channel, str);
			/* appendstring(cp, str); */
			/* appendprompt(cp, 0); */
		}
		pclose(fp);
	}
	return;
}
